import io
from pathlib import Path

import numpy
import httpx
from PIL import Image, ImageFont, ImageDraw
from matplotlib import pyplot as plt
from matplotlib import font_manager as fm
from nonebot.typing import T_State
from nonebot.adapters.onebot.v11 import Event, Bot, Message, MessageSegment
from nonebot import on_command

from nonebot_plugin_ocgbot_v2.libraries.globalMessage import image_path, font_path
from nonebot_plugin_ocgbot_v2.libraries.image import image_to_base64

url = "https://sapi.moecube.com:444/ygopro/analytics/deck/type?type=day&source=mycard-athletic"
# 测试数据
# json1 = '[{"name":"珠泪哀歌族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"2578","tags":["珠泪哀歌族-白雪","珠泪哀歌族-俱舍怒威族","珠泪哀歌族-影依"],"matchup":{"first":{"decka":"珠泪哀歌族","win":"2659","draw":"1","lose":"2071"},"second":{"deckb":"珠泪哀歌族","win":"2401","draw":"0","lose":"2232"}}},{"name":"俱舍怒威族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"1656","tags":["俱舍怒威族-魔里","俱舍怒威族-壹世坏","俱舍怒威族-次元场"],"matchup":{"first":{"decka":"俱舍怒威族","win":"1979","draw":"0","lose":"1273"},"second":{"deckb":"俱舍怒威族","win":"1593","draw":"0","lose":"1590"}}},{"name":"纯爱妖精","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"1633","tags":["纯爱妖精-拯救的桥梁","纯爱妖精-次元场","纯爱妖精-魔里"],"matchup":{"first":{"decka":"纯爱妖精","win":"1751","draw":"0","lose":"1231"},"second":{"deckb":"纯爱妖精","win":"1431","draw":"0","lose":"1449"}}},{"name":"救祓少女","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"1033","tags":["救祓少女-次元场","救祓少女-同调系","救祓少女-深渊之兽"],"matchup":{"first":{"decka":"救祓少女","win":"1081","draw":"0","lose":"768"},"second":{"deckb":"救祓少女","win":"928","draw":"0","lose":"864"}}},{"name":"地属性","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"1005","tags":["地属性-超重武者","地属性-割草","地属性-神殿守卫者"],"matchup":{"first":{"decka":"地属性","win":"1054","draw":"0","lose":"585"},"second":{"deckb":"地属性","win":"794","draw":"0","lose":"722"}}},{"name":"阿不思","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"958","tags":["阿不思-死狱乡","阿不思-深渊之兽","阿不思-教导"],"matchup":{"first":{"decka":"阿不思","win":"1075","draw":"0","lose":"802"},"second":{"deckb":"阿不思","win":"942","draw":"0","lose":"832"}}},{"name":"深渊之兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"935","tags":["深渊之兽-卫星闪灵","深渊之兽-同调士","深渊之兽-朋克"],"matchup":{"first":{"decka":"深渊之兽","win":"913","draw":"0","lose":"748"},"second":{"deckb":"深渊之兽","win":"901","draw":"0","lose":"723"}}},{"name":"神碑","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"896","tags":["神碑-削命","神碑-次元场","神碑-杯面"],"matchup":{"first":{"decka":"神碑","win":"996","draw":"0","lose":"689"},"second":{"deckb":"神碑","win":"855","draw":"0","lose":"728"}}},{"name":"超重武者","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"692","tags":["超重武者-深渊之兽","超重武者-PSY","超重武者-自奏圣乐"],"matchup":{"first":{"decka":"超重武者","win":"738","draw":"0","lose":"506"},"second":{"deckb":"超重武者","win":"609","draw":"0","lose":"521"}}},{"name":"拉比林斯迷宫","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"679","tags":["拉比林斯迷宫-强金","拉比林斯迷宫-病毒","拉比林斯迷宫-教导"],"matchup":{"first":{"decka":"拉比林斯迷宫","win":"663","draw":"0","lose":"548"},"second":{"deckb":"拉比林斯迷宫","win":"678","draw":"0","lose":"502"}}},{"name":"弹丸","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"664","tags":["弹丸-深渊之兽","弹丸-黑白龙","弹丸-割草"],"matchup":{"first":{"decka":"弹丸","win":"696","draw":"0","lose":"489"},"second":{"deckb":"弹丸","win":"578","draw":"0","lose":"547"}}},{"name":"魔救","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"569","tags":["魔救-割草","魔救-超重武者","魔救-杯面"],"matchup":{"first":{"decka":"魔救","win":"540","draw":"0","lose":"384"},"second":{"deckb":"魔救","win":"470","draw":"0","lose":"413"}}},{"name":"闪刀姬","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"518","tags":["闪刀姬-魔导","闪刀姬-神碑","闪刀姬-滤抽"],"matchup":{"first":{"decka":"闪刀姬","win":"335","draw":"0","lose":"491"},"second":{"deckb":"闪刀姬","win":"585","draw":"0","lose":"418"}}},{"name":"世坏","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"511","tags":["世坏-俱舍怒威族","世坏-卫星闪灵","世坏-深渊之兽"],"matchup":{"first":{"decka":"世坏","win":"511","draw":"0","lose":"471"},"second":{"deckb":"世坏","win":"529","draw":"0","lose":"420"}}},{"name":"电子界","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"475","tags":["电子界-斩机","电子界-诱发型"],"matchup":{"first":{"decka":"电子界","win":"447","draw":"0","lose":"372"},"second":{"deckb":"电子界","win":"439","draw":"0","lose":"313"}}},{"name":"铁兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"451","tags":["铁兽-卫星闪灵","铁兽-毒蛾"],"matchup":{"first":{"decka":"铁兽","win":"529","draw":"0","lose":"350"},"second":{"deckb":"铁兽","win":"412","draw":"0","lose":"391"}}},{"name":"相剑","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"437","tags":["相剑-超重武者","相剑-教导","相剑-杯面"],"matchup":{"first":{"decka":"相剑","win":"376","draw":"0","lose":"360"},"second":{"deckb":"相剑","win":"389","draw":"0","lose":"309"}}},{"name":"英雄","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"326","tags":["英雄-凤凰人","英雄-假面","英雄-神召"],"matchup":{"first":{"decka":"英雄","win":"218","draw":"0","lose":"294"},"second":{"deckb":"英雄","win":"295","draw":"0","lose":"172"}}},{"name":"EM魔术师","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"286","tags":["EM魔术师-杯面","EM魔术师-魔里","EM魔术师-毒蛾"],"matchup":{"first":{"decka":"EM魔术师","win":"265","draw":"0","lose":"275"},"second":{"deckb":"EM魔术师","win":"310","draw":"0","lose":"203"}}},{"name":"虫惑魔","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"284","tags":["虫惑魔-神碑","虫惑魔-超重武者","虫惑魔-兽带"],"matchup":{"first":{"decka":"虫惑魔","win":"261","draw":"0","lose":"243"},"second":{"deckb":"虫惑魔","win":"259","draw":"0","lose":"222"}}},{"name":"随风旅鸟","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"265","tags":["随风旅鸟-强金","随风旅鸟-次元场","随风旅鸟-天空龙"],"matchup":{"first":{"decka":"随风旅鸟","win":"293","draw":"0","lose":"226"},"second":{"deckb":"随风旅鸟","win":"315","draw":"1","lose":"222"}}},{"name":"恐啡肽狂龙","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"253","tags":["恐啡肽狂龙-病毒","恐啡肽狂龙-扎克","恐啡肽狂龙-削命"],"matchup":{"first":{"decka":"恐啡肽狂龙","win":"201","draw":"2","lose":"202"},"second":{"deckb":"恐啡肽狂龙","win":"199","draw":"0","lose":"146"}}},{"name":"影依","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"208","tags":["影依-白雪","影依-壹世坏","影依-割草"],"matchup":{"first":{"decka":"影依","win":"199","draw":"0","lose":"226"},"second":{"deckb":"影依","win":"244","draw":"0","lose":"181"}}},{"name":"双子","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"197","tags":["双子-AF","双子-毒蛾"],"matchup":{"first":{"decka":"双子","win":"196","draw":"0","lose":"168"},"second":{"deckb":"双子","win":"166","draw":"0","lose":"120"}}},{"name":"勇者同调系","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"180","tags":["勇者同调系-朋克","勇者同调系-白雪","勇者同调系-深渊之兽"],"matchup":{"first":{"decka":"勇者同调系","win":"162","draw":"0","lose":"149"},"second":{"deckb":"勇者同调系","win":"186","draw":"0","lose":"113"}}},{"name":"王战","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"165","tags":["王战-召唤兽","王战-源数","王战-强金"],"matchup":{"first":{"decka":"王战","win":"177","draw":"0","lose":"154"},"second":{"deckb":"王战","win":"189","draw":"0","lose":"142"}}},{"name":"雷龙","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"154","tags":["雷龙-深渊之兽","雷龙-朋克","雷龙-白雪"],"matchup":{"first":{"decka":"雷龙","win":"98","draw":"0","lose":"104"},"second":{"deckb":"雷龙","win":"118","draw":"0","lose":"80"}}},{"name":"海晶少女","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"152","tags":["海晶少女-冰水","海晶少女-御巫","海晶少女-灰篮"],"matchup":{"first":{"decka":"海晶少女","win":"147","draw":"0","lose":"122"},"second":{"deckb":"海晶少女","win":"125","draw":"0","lose":"114"}}},{"name":"迷之卡组","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"149","tags":[],"matchup":{"first":{"decka":"迷之卡组","win":"161","draw":"0","lose":"110"},"second":{"deckb":"迷之卡组","win":"162","draw":"0","lose":"145"}}},{"name":"御巫","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"142","tags":["御巫-坏兽","御巫-强金","御巫-勇者"],"matchup":{"first":{"decka":"御巫","win":"70","draw":"0","lose":"69"},"second":{"deckb":"御巫","win":"245","draw":"0","lose":"214"}}},{"name":"卫星闪灵","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"137","tags":["卫星闪灵-深渊之兽","卫星闪灵-勇者","卫星闪灵-幻魔"],"matchup":{"first":{"decka":"卫星闪灵","win":"141","draw":"0","lose":"116"},"second":{"deckb":"卫星闪灵","win":"125","draw":"0","lose":"129"}}},{"name":"电脑堺","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"132","tags":["电脑堺-勇者","电脑堺-白雪","电脑堺-朋克"],"matchup":{"first":{"decka":"电脑堺","win":"163","draw":"0","lose":"152"},"second":{"deckb":"电脑堺","win":"169","draw":"0","lose":"107"}}},{"name":"龙剑士","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"121","tags":["龙剑士-威风妖怪","龙剑士-雾动机龙","龙剑士-超重武者"],"matchup":{"first":{"decka":"龙剑士","win":"108","draw":"0","lose":"110"},"second":{"deckb":"龙剑士","win":"92","draw":"0","lose":"84"}}},{"name":"旋风黑羽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"118","tags":["旋风黑羽-深渊之兽","旋风黑羽-病毒"],"matchup":{"first":{"decka":"旋风黑羽","win":"82","draw":"0","lose":"92"},"second":{"deckb":"旋风黑羽","win":"108","draw":"0","lose":"79"}}},{"name":"自奏圣乐","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"111","tags":["自奏圣乐-废铁","自奏圣乐-朋克","自奏圣乐-深渊之兽"],"matchup":{"first":{"decka":"自奏圣乐","win":"104","draw":"0","lose":"101"},"second":{"deckb":"自奏圣乐","win":"129","draw":"0","lose":"98"}}},{"name":"六花","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"103","tags":["六花-圣天树","六花-兽带"],"matchup":{"first":{"decka":"六花","win":"129","draw":"0","lose":"96"},"second":{"deckb":"六花","win":"119","draw":"0","lose":"101"}}},{"name":"自然","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"100","tags":["自然-割草","自然-白雪","自然-神碑"],"matchup":{"first":{"decka":"自然","win":"163","draw":"0","lose":"149"},"second":{"deckb":"自然","win":"168","draw":"0","lose":"135"}}},{"name":"黄金国","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"92","tags":["黄金国-强金","黄金国-割草","黄金国-教导"],"matchup":{"first":{"decka":"黄金国","win":"93","draw":"0","lose":"101"},"second":{"deckb":"黄金国","win":"128","draw":"0","lose":"56"}}},{"name":"地中族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"91","tags":["地中族-强金"],"matchup":{"first":{"decka":"地中族","win":"104","draw":"0","lose":"101"},"second":{"deckb":"地中族","win":"77","draw":"0","lose":"84"}}},{"name":"神数","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"89","tags":["神数-龙星","神数-恩底弥翁","神数-超重武者"],"matchup":{"first":{"decka":"神数","win":"89","draw":"0","lose":"71"},"second":{"deckb":"神数","win":"100","draw":"0","lose":"46"}}},{"name":"妮穆蕾莉娅","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"88","tags":["妮穆蕾莉娅-暴食","妮穆蕾莉娅-强金","妮穆蕾莉娅-红莲魔兽"],"matchup":{"first":{"decka":"妮穆蕾莉娅","win":"47","draw":"0","lose":"73"},"second":{"deckb":"妮穆蕾莉娅","win":"76","draw":"0","lose":"56"}}},{"name":"忍者","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"87","tags":["忍者-杯面","忍者-强金","忍者-斩机"],"matchup":{"first":{"decka":"忍者","win":"64","draw":"0","lose":"62"},"second":{"deckb":"忍者","win":"72","draw":"0","lose":"50"}}},{"name":"转生炎兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"84","tags":["转生炎兽-斩机"],"matchup":{"first":{"decka":"转生炎兽","win":"57","draw":"0","lose":"81"},"second":{"deckb":"转生炎兽","win":"82","draw":"0","lose":"53"}}},{"name":"未界域暗黑界","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"84","tags":["未界域暗黑界-白雪","未界域暗黑界-病毒","未界域暗黑界-假面"],"matchup":{"first":{"decka":"未界域暗黑界","win":"46","draw":"0","lose":"75"},"second":{"deckb":"未界域暗黑界","win":"72","draw":"0","lose":"51"}}},{"name":"秘旋谍","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"79","tags":["秘旋谍-割草","秘旋谍-勇者","秘旋谍-朋克"],"matchup":{"first":{"decka":"秘旋谍","win":"82","draw":"0","lose":"55"},"second":{"deckb":"秘旋谍","win":"86","draw":"0","lose":"71"}}},{"name":"群豪","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"78","tags":["群豪-魔里","群豪-超重武者","群豪-神数"],"matchup":{"first":{"decka":"群豪","win":"69","draw":"0","lose":"60"},"second":{"deckb":"群豪","win":"52","draw":"0","lose":"42"}}},{"name":"火灵天星","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"77","tags":["火灵天星-斩机"],"matchup":{"first":{"decka":"火灵天星","win":"55","draw":"0","lose":"53"},"second":{"deckb":"火灵天星","win":"67","draw":"0","lose":"46"}}},{"name":"虹皇","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"75","tags":["虹皇-hero","虹皇-凤凰人","虹皇-假面"],"matchup":{"first":{"decka":"虹皇","win":"17","draw":"0","lose":"37"},"second":{"deckb":"虹皇","win":"77","draw":"0","lose":"38"}}},{"name":"星骑士","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"74","tags":["星骑士-次元场"],"matchup":{"first":{"decka":"星骑士","win":"54","draw":"0","lose":"46"},"second":{"deckb":"星骑士","win":"47","draw":"0","lose":"37"}}},{"name":"遗式","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"72","tags":["遗式-卫星闪灵","遗式-杯面"],"matchup":{"first":{"decka":"遗式","win":"64","draw":"0","lose":"54"},"second":{"deckb":"遗式","win":"68","draw":"0","lose":"52"}}},{"name":"抒情歌鸲","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"71","tags":["抒情歌鸲-七皇剑","抒情歌鸲-金华猫"],"matchup":{"first":{"decka":"抒情歌鸲","win":"79","draw":"0","lose":"57"},"second":{"deckb":"抒情歌鸲","win":"77","draw":"0","lose":"74"}}},{"name":"Metabeat","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"71","tags":["Metabeat-削命","Metabeat-强金","Metabeat-红莲魔兽"],"matchup":{"first":{"decka":"Metabeat","win":"72","draw":"0","lose":"56"},"second":{"deckb":"Metabeat","win":"78","draw":"0","lose":"59"}}},{"name":"龙辉巧","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"66","tags":["龙辉巧-电子化天使","龙辉巧-神光","龙辉巧-杯面"],"matchup":{"first":{"decka":"龙辉巧","win":"66","draw":"0","lose":"52"},"second":{"deckb":"龙辉巧","win":"74","draw":"0","lose":"35"}}},{"name":"电子龙","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"66","tags":["电子龙-银河","电子龙-暗电子","电子龙-兽带"],"matchup":{"first":{"decka":"电子龙","win":"22","draw":"0","lose":"38"},"second":{"deckb":"电子龙","win":"100","draw":"0","lose":"57"}}},{"name":"宝玉","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"63","tags":["宝玉-虹龙","宝玉-拯救的桥梁","宝玉-异热同心"],"matchup":{"first":{"decka":"宝玉","win":"31","draw":"0","lose":"58"},"second":{"deckb":"宝玉","win":"61","draw":"0","lose":"20"}}},{"name":"星圣","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"56","tags":["星圣-星骑士","星圣-次元场"],"matchup":{"first":{"decka":"星圣","win":"36","draw":"0","lose":"32"},"second":{"deckb":"星圣","win":"36","draw":"0","lose":"40"}}},{"name":"青眼","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"55","tags":["青眼-深渊之兽","青眼-假面","青眼-融合"],"matchup":{"first":{"decka":"青眼","win":"10","draw":"0","lose":"44"},"second":{"deckb":"青眼","win":"63","draw":"0","lose":"19"}}},{"name":"朋克","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"49","tags":["朋克-深渊之兽","朋克-割草","朋克-白雪"],"matchup":{"first":{"decka":"朋克","win":"53","draw":"0","lose":"53"},"second":{"deckb":"朋克","win":"58","draw":"0","lose":"49"}}},{"name":"恩底弥翁","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"48","tags":["恩底弥翁-滤抽","恩底弥翁-魔导兽","恩底弥翁-魔里"],"matchup":{"first":{"decka":"恩底弥翁","win":"51","draw":"0","lose":"58"},"second":{"deckb":"恩底弥翁","win":"56","draw":"0","lose":"33"}}},{"name":"咒眼","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"48","tags":["咒眼-强金","咒眼-俱舍怒威族"],"matchup":{"first":{"decka":"咒眼","win":"67","draw":"0","lose":"49"},"second":{"deckb":"咒眼","win":"59","draw":"1","lose":"56"}}},{"name":"海系","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"47","tags":["海系-俱舍怒威族","海系-冰水","海系-强金"],"matchup":{"first":{"decka":"海系","win":"21","draw":"0","lose":"21"},"second":{"deckb":"海系","win":"44","draw":"0","lose":"25"}}},{"name":"DD","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"46","tags":["DD-假面","DD-病毒"],"matchup":{"first":{"decka":"DD","win":"45","draw":"0","lose":"34"},"second":{"deckb":"DD","win":"43","draw":"0","lose":"36"}}},{"name":"幻影骑士团","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"44","tags":["幻影骑士团-朋克","幻影骑士团-未界域","幻影骑士团-深渊之兽"],"matchup":{"first":{"decka":"幻影骑士团","win":"40","draw":"0","lose":"50"},"second":{"deckb":"幻影骑士团","win":"57","draw":"0","lose":"36"}}},{"name":"银河光子","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"41","tags":["银河光子-深渊之兽","银河光子-七皇剑","银河光子-斩机"],"matchup":{"first":{"decka":"银河光子","win":"27","draw":"0","lose":"48"},"second":{"deckb":"银河光子","win":"50","draw":"0","lose":"18"}}},{"name":"幻变骚灵","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"41","tags":["幻变骚灵-强金","幻变骚灵-魔里"],"matchup":{"first":{"decka":"幻变骚灵","win":"47","draw":"0","lose":"43"},"second":{"deckb":"幻变骚灵","win":"51","draw":"0","lose":"35"}}},{"name":"同调士勇者同调系","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"40","tags":[],"matchup":{"first":{"decka":"同调士勇者同调系","win":"50","draw":"0","lose":"43"},"second":{"deckb":"同调士勇者同调系","win":"53","draw":"0","lose":"33"}}},{"name":"教导","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"37","tags":["教导-深渊之兽","教导-影依","教导-魔里"],"matchup":{"first":{"decka":"教导","win":"19","draw":"0","lose":"28"},"second":{"deckb":"教导","win":"24","draw":"0","lose":"29"}}},{"name":"恐龙族废铁","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"36","tags":["恐龙族废铁-进化药"],"matchup":{"first":{"decka":"恐龙族废铁","win":"42","draw":"0","lose":"39"},"second":{"deckb":"恐龙族废铁","win":"42","draw":"0","lose":"28"}}},{"name":"恐吓爪牙族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"35","tags":["恐吓爪牙族-俱舍怒威族"],"matchup":{"first":{"decka":"恐吓爪牙族","win":"48","draw":"0","lose":"25"},"second":{"deckb":"恐吓爪牙族","win":"33","draw":"0","lose":"27"}}},{"name":"海造贼","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"35","tags":["海造贼-勇者"],"matchup":{"first":{"decka":"海造贼","win":"49","draw":"0","lose":"49"},"second":{"deckb":"海造贼","win":"57","draw":"0","lose":"48"}}},{"name":"斩机","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"35","tags":["斩机-恐啡肽狂龙"],"matchup":{"first":{"decka":"斩机","win":"36","draw":"0","lose":"33"},"second":{"deckb":"斩机","win":"55","draw":"0","lose":"30"}}},{"name":"救援ACE队","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"32","tags":["救援ACE队-次元场","救援ACE队-强金"],"matchup":{"first":{"decka":"救援ACE队","win":"43","draw":"0","lose":"33"},"second":{"deckb":"救援ACE队","win":"40","draw":"0","lose":"21"}}},{"name":"战华","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"31","tags":["战华-强金","战华-黄金国"],"matchup":{"first":{"decka":"战华","win":"14","draw":"0","lose":"14"},"second":{"deckb":"战华","win":"29","draw":"0","lose":"29"}}},{"name":"魔偶甜点","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"31","tags":["魔偶甜点-超重武者"],"matchup":{"first":{"decka":"魔偶甜点","win":"29","draw":"0","lose":"30"},"second":{"deckb":"魔偶甜点","win":"33","draw":"0","lose":"25"}}},{"name":"勇者","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"27","tags":["勇者-深渊之兽","勇者-朋克","勇者-强金"],"matchup":{"first":{"decka":"勇者","win":"22","draw":"0","lose":"24"},"second":{"deckb":"勇者","win":"29","draw":"0","lose":"23"}}},{"name":"坏兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"27","tags":["坏兽-辉夜","坏兽-未界域","坏兽-白雪"],"matchup":{"first":{"decka":"坏兽","win":"9","draw":"0","lose":"9"},"second":{"deckb":"坏兽","win":"66","draw":"0","lose":"64"}}},{"name":"割草黯黑狱火机","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"26","tags":["割草黯黑狱火机-推理门","割草黯黑狱火机-强金","割草黯黑狱火机-白雪"],"matchup":{"first":{"decka":"割草黯黑狱火机","win":"4","draw":"0","lose":"9"},"second":{"deckb":"割草黯黑狱火机","win":"42","draw":"0","lose":"32"}}},{"name":"均卡beat","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"26","tags":["均卡beat-削命","均卡beat-辉夜","均卡beat-次元场"],"matchup":{"first":{"decka":"均卡beat","win":"45","draw":"0","lose":"34"},"second":{"deckb":"均卡beat","win":"49","draw":"0","lose":"30"}}},{"name":"龙剑士魔里","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"24","tags":["龙剑士魔里-威风妖怪","龙剑士魔里-雾动机龙","龙剑士魔里-超重武者"],"matchup":{"first":{"decka":"龙剑士魔里","win":"8","draw":"0","lose":"26"},"second":{"deckb":"龙剑士魔里","win":"25","draw":"0","lose":"9"}}},{"name":"魔女术","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"24","tags":["魔女术-魔里","魔女术-教导","魔女术-割草"],"matchup":{"first":{"decka":"魔女术","win":"15","draw":"0","lose":"27"},"second":{"deckb":"魔女术","win":"45","draw":"0","lose":"18"}}},{"name":"弗兰克特化","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"23","tags":["弗兰克特化-废铁","弗兰克特化-恐龙族"],"matchup":{"first":{"decka":"弗兰克特化","win":"3","draw":"0","lose":"12"},"second":{"deckb":"弗兰克特化","win":"12","draw":"0","lose":"0"}}},{"name":"淘气仙星","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"23","tags":["淘气仙星-强金","淘气仙星-暴食","淘气仙星-深渊之兽"],"matchup":{"first":{"decka":"淘气仙星","win":"6","draw":"0","lose":"14"},"second":{"deckb":"淘气仙星","win":"10","draw":"0","lose":"11"}}},{"name":"空牙团","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"22","tags":["空牙团-神碑","空牙团-卫星闪灵","空牙团-杯面"],"matchup":{"first":{"decka":"空牙团","win":"8","draw":"0","lose":"13"},"second":{"deckb":"空牙团","win":"14","draw":"0","lose":"8"}}},{"name":"PSY骨架","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"22","tags":["PSY骨架-超重武者","PSY骨架-同调系","PSY骨架-深渊之兽"],"matchup":{"first":{"decka":"PSY骨架","win":"17","draw":"0","lose":"16"},"second":{"deckb":"PSY骨架","win":"26","draw":"0","lose":"17"}}},{"name":"半龙女仆","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"21","tags":["半龙女仆-深渊之兽","半龙女仆-死狱乡","半龙女仆-烙印"],"matchup":{"first":{"decka":"半龙女仆","win":"16","draw":"0","lose":"21"},"second":{"deckb":"半龙女仆","win":"16","draw":"0","lose":"11"}}},{"name":"水四阶","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"20","tags":["水四阶-七皇剑","水四阶-斩机"],"matchup":{"first":{"decka":"水四阶","win":"4","draw":"0","lose":"14"},"second":{"deckb":"水四阶","win":"11","draw":"0","lose":"14"}}},{"name":"恐龙族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"20","tags":["恐龙族-进化药"],"matchup":{"first":{"decka":"恐龙族","win":"15","draw":"0","lose":"7"},"second":{"deckb":"恐龙族","win":"11","draw":"0","lose":"12"}}},{"name":"黑魔术师","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"20","tags":["黑魔术师-魔里","黑魔术师-传说之龙","黑魔术师-高仪"],"matchup":{"first":{"decka":"黑魔术师","win":"7","draw":"0","lose":"25"},"second":{"deckb":"黑魔术师","win":"19","draw":"0","lose":"12"}}},{"name":"护宝炮妖","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"19","tags":["护宝炮妖-斩机","护宝炮妖-兽带","护宝炮妖-割草"],"matchup":{"first":{"decka":"护宝炮妖","win":"21","draw":"0","lose":"8"},"second":{"deckb":"护宝炮妖","win":"25","draw":"0","lose":"13"}}},{"name":"三幻魔","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"19","tags":["三幻魔-混沌幻魔","三幻魔-假面","三幻魔-十二兽"],"matchup":{"first":{"decka":"三幻魔","win":"9","draw":"0","lose":"18"},"second":{"deckb":"三幻魔","win":"12","draw":"0","lose":"10"}}},{"name":"帝","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"19","tags":["帝-领域","帝-随风旅鸟","帝-虚无魔人"],"matchup":{"first":{"decka":"帝","win":"6","draw":"0","lose":"18"},"second":{"deckb":"帝","win":"16","draw":"0","lose":"3"}}},{"name":"辉夜坏兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"18","tags":["辉夜坏兽-次元场","辉夜坏兽-雪花","辉夜坏兽-超重武者"],"matchup":{"first":{"decka":"辉夜坏兽","win":"4","draw":"0","lose":"3"},"second":{"deckb":"辉夜坏兽","win":"52","draw":"0","lose":"36"}}},{"name":"教导召唤兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"18","tags":["教导召唤兽-影依","教导召唤兽-割草","教导召唤兽-深渊之兽"],"matchup":{"first":{"decka":"教导召唤兽","win":"17","draw":"0","lose":"13"},"second":{"deckb":"教导召唤兽","win":"23","draw":"0","lose":"10"}}},{"name":"恐龙真龙","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"18","tags":["恐龙真龙-进化药","恐龙真龙-废铁"],"matchup":{"first":{"decka":"恐龙真龙","win":"24","draw":"0","lose":"11"},"second":{"deckb":"恐龙真龙","win":"21","draw":"1","lose":"19"}}},{"name":"末那愚子族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"17","tags":["末那愚子族-深渊之兽","末那愚子族-卫星闪灵"],"matchup":{"first":{"decka":"末那愚子族","win":"15","draw":"0","lose":"22"},"second":{"deckb":"末那愚子族","win":"28","draw":"0","lose":"17"}}},{"name":"削命真龙","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"17","tags":["削命真龙-强金","削命真龙-次元场"],"matchup":{"first":{"decka":"削命真龙","win":"23","draw":"0","lose":"23"},"second":{"deckb":"削命真龙","win":"27","draw":"0","lose":"21"}}},{"name":"龙连接","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"17","tags":["龙连接-深渊之兽","龙连接-黑白龙","龙连接-无形噬体"],"matchup":{"first":{"decka":"龙连接","win":"24","draw":"0","lose":"11"},"second":{"deckb":"龙连接","win":"28","draw":"0","lose":"24"}}},{"name":"魔界剧团","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"16","tags":["魔界剧团-无形噬体","魔界剧团-病毒","魔界剧团-AF"],"matchup":{"first":{"decka":"魔界剧团","win":"9","draw":"0","lose":"8"},"second":{"deckb":"魔界剧团","win":"8","draw":"0","lose":"4"}}},{"name":"黑羽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"16","tags":["黑羽-深渊之兽"],"matchup":{"first":{"decka":"黑羽","win":"13","draw":"0","lose":"16"},"second":{"deckb":"黑羽","win":"12","draw":"0","lose":"9"}}},{"name":"源数","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"16","tags":["源数-翼神龙","源数-PSY","源数-七皇剑"],"matchup":{"first":{"decka":"源数","win":"4","draw":"0","lose":"12"},"second":{"deckb":"源数","win":"41","draw":"0","lose":"36"}}}]'
# json2 = '[{"name":"俱舍怒威族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"1656","tags":["俱舍怒威族-魔里","俱舍怒威族-壹世坏","俱舍怒威族-次元场"],"matchup":{"first":{"decka":"俱舍怒威族","win":"1979","draw":"0","lose":"1273"},"second":{"deckb":"俱舍怒威族","win":"1593","draw":"0","lose":"1590"}}},{"name":"纯爱妖精","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"1633","tags":["纯爱妖精-拯救的桥梁","纯爱妖精-次元场","纯爱妖精-魔里"],"matchup":{"first":{"decka":"纯爱妖精","win":"1751","draw":"0","lose":"1231"},"second":{"deckb":"纯爱妖精","win":"1431","draw":"0","lose":"1449"}}},{"name":"救祓少女","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"1033","tags":["救祓少女-次元场","救祓少女-同调系","救祓少女-深渊之兽"],"matchup":{"first":{"decka":"救祓少女","win":"1081","draw":"0","lose":"768"},"second":{"deckb":"救祓少女","win":"928","draw":"0","lose":"864"}}},{"name":"地属性","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"1005","tags":["地属性-超重武者","地属性-割草","地属性-神殿守卫者"],"matchup":{"first":{"decka":"地属性","win":"1054","draw":"0","lose":"585"},"second":{"deckb":"地属性","win":"794","draw":"0","lose":"722"}}},{"name":"阿不思","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"958","tags":["阿不思-死狱乡","阿不思-深渊之兽","阿不思-教导"],"matchup":{"first":{"decka":"阿不思","win":"1075","draw":"0","lose":"802"},"second":{"deckb":"阿不思","win":"942","draw":"0","lose":"832"}}},{"name":"深渊之兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"935","tags":["深渊之兽-卫星闪灵","深渊之兽-同调士","深渊之兽-朋克"],"matchup":{"first":{"decka":"深渊之兽","win":"913","draw":"0","lose":"748"},"second":{"deckb":"深渊之兽","win":"901","draw":"0","lose":"723"}}},{"name":"神碑","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"896","tags":["神碑-削命","神碑-次元场","神碑-杯面"],"matchup":{"first":{"decka":"神碑","win":"996","draw":"0","lose":"689"},"second":{"deckb":"神碑","win":"855","draw":"0","lose":"728"}}},{"name":"超重武者","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"692","tags":["超重武者-深渊之兽","超重武者-PSY","超重武者-自奏圣乐"],"matchup":{"first":{"decka":"超重武者","win":"738","draw":"0","lose":"506"},"second":{"deckb":"超重武者","win":"609","draw":"0","lose":"521"}}},{"name":"拉比林斯迷宫","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"679","tags":["拉比林斯迷宫-强金","拉比林斯迷宫-病毒","拉比林斯迷宫-教导"],"matchup":{"first":{"decka":"拉比林斯迷宫","win":"663","draw":"0","lose":"548"},"second":{"deckb":"拉比林斯迷宫","win":"678","draw":"0","lose":"502"}}},{"name":"弹丸","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"664","tags":["弹丸-深渊之兽","弹丸-黑白龙","弹丸-割草"],"matchup":{"first":{"decka":"弹丸","win":"696","draw":"0","lose":"489"},"second":{"deckb":"弹丸","win":"578","draw":"0","lose":"547"}}},{"name":"魔救","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"569","tags":["魔救-割草","魔救-超重武者","魔救-杯面"],"matchup":{"first":{"decka":"魔救","win":"540","draw":"0","lose":"384"},"second":{"deckb":"魔救","win":"470","draw":"0","lose":"413"}}},{"name":"闪刀姬","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"518","tags":["闪刀姬-魔导","闪刀姬-神碑","闪刀姬-滤抽"],"matchup":{"first":{"decka":"闪刀姬","win":"335","draw":"0","lose":"491"},"second":{"deckb":"闪刀姬","win":"585","draw":"0","lose":"418"}}},{"name":"世坏","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"511","tags":["世坏-俱舍怒威族","世坏-卫星闪灵","世坏-深渊之兽"],"matchup":{"first":{"decka":"世坏","win":"511","draw":"0","lose":"471"},"second":{"deckb":"世坏","win":"529","draw":"0","lose":"420"}}},{"name":"电子界","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"475","tags":["电子界-斩机","电子界-诱发型"],"matchup":{"first":{"decka":"电子界","win":"447","draw":"0","lose":"372"},"second":{"deckb":"电子界","win":"439","draw":"0","lose":"313"}}},{"name":"铁兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"451","tags":["铁兽-卫星闪灵","铁兽-毒蛾"],"matchup":{"first":{"decka":"铁兽","win":"529","draw":"0","lose":"350"},"second":{"deckb":"铁兽","win":"412","draw":"0","lose":"391"}}},{"name":"相剑","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"437","tags":["相剑-超重武者","相剑-教导","相剑-杯面"],"matchup":{"first":{"decka":"相剑","win":"376","draw":"0","lose":"360"},"second":{"deckb":"相剑","win":"389","draw":"0","lose":"309"}}},{"name":"英雄","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"326","tags":["英雄-凤凰人","英雄-假面","英雄-神召"],"matchup":{"first":{"decka":"英雄","win":"218","draw":"0","lose":"294"},"second":{"deckb":"英雄","win":"295","draw":"0","lose":"172"}}},{"name":"EM魔术师","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"286","tags":["EM魔术师-杯面","EM魔术师-魔里","EM魔术师-毒蛾"],"matchup":{"first":{"decka":"EM魔术师","win":"265","draw":"0","lose":"275"},"second":{"deckb":"EM魔术师","win":"310","draw":"0","lose":"203"}}},{"name":"虫惑魔","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"284","tags":["虫惑魔-神碑","虫惑魔-超重武者","虫惑魔-兽带"],"matchup":{"first":{"decka":"虫惑魔","win":"261","draw":"0","lose":"243"},"second":{"deckb":"虫惑魔","win":"259","draw":"0","lose":"222"}}},{"name":"随风旅鸟","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"265","tags":["随风旅鸟-强金","随风旅鸟-次元场","随风旅鸟-天空龙"],"matchup":{"first":{"decka":"随风旅鸟","win":"293","draw":"0","lose":"226"},"second":{"deckb":"随风旅鸟","win":"315","draw":"1","lose":"222"}}},{"name":"恐啡肽狂龙","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"253","tags":["恐啡肽狂龙-病毒","恐啡肽狂龙-扎克","恐啡肽狂龙-削命"],"matchup":{"first":{"decka":"恐啡肽狂龙","win":"201","draw":"2","lose":"202"},"second":{"deckb":"恐啡肽狂龙","win":"199","draw":"0","lose":"146"}}},{"name":"影依","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"208","tags":["影依-白雪","影依-壹世坏","影依-割草"],"matchup":{"first":{"decka":"影依","win":"199","draw":"0","lose":"226"},"second":{"deckb":"影依","win":"244","draw":"0","lose":"181"}}},{"name":"双子","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"197","tags":["双子-AF","双子-毒蛾"],"matchup":{"first":{"decka":"双子","win":"196","draw":"0","lose":"168"},"second":{"deckb":"双子","win":"166","draw":"0","lose":"120"}}},{"name":"勇者同调系","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"180","tags":["勇者同调系-朋克","勇者同调系-白雪","勇者同调系-深渊之兽"],"matchup":{"first":{"decka":"勇者同调系","win":"162","draw":"0","lose":"149"},"second":{"deckb":"勇者同调系","win":"186","draw":"0","lose":"113"}}},{"name":"王战","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"165","tags":["王战-召唤兽","王战-源数","王战-强金"],"matchup":{"first":{"decka":"王战","win":"177","draw":"0","lose":"154"},"second":{"deckb":"王战","win":"189","draw":"0","lose":"142"}}},{"name":"雷龙","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"154","tags":["雷龙-深渊之兽","雷龙-朋克","雷龙-白雪"],"matchup":{"first":{"decka":"雷龙","win":"98","draw":"0","lose":"104"},"second":{"deckb":"雷龙","win":"118","draw":"0","lose":"80"}}},{"name":"海晶少女","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"152","tags":["海晶少女-冰水","海晶少女-御巫","海晶少女-灰篮"],"matchup":{"first":{"decka":"海晶少女","win":"147","draw":"0","lose":"122"},"second":{"deckb":"海晶少女","win":"125","draw":"0","lose":"114"}}},{"name":"迷之卡组","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"149","tags":[],"matchup":{"first":{"decka":"迷之卡组","win":"161","draw":"0","lose":"110"},"second":{"deckb":"迷之卡组","win":"162","draw":"0","lose":"145"}}},{"name":"御巫","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"142","tags":["御巫-坏兽","御巫-强金","御巫-勇者"],"matchup":{"first":{"decka":"御巫","win":"70","draw":"0","lose":"69"},"second":{"deckb":"御巫","win":"245","draw":"0","lose":"214"}}},{"name":"卫星闪灵","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"137","tags":["卫星闪灵-深渊之兽","卫星闪灵-勇者","卫星闪灵-幻魔"],"matchup":{"first":{"decka":"卫星闪灵","win":"141","draw":"0","lose":"116"},"second":{"deckb":"卫星闪灵","win":"125","draw":"0","lose":"129"}}},{"name":"电脑堺","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"132","tags":["电脑堺-勇者","电脑堺-白雪","电脑堺-朋克"],"matchup":{"first":{"decka":"电脑堺","win":"163","draw":"0","lose":"152"},"second":{"deckb":"电脑堺","win":"169","draw":"0","lose":"107"}}},{"name":"龙剑士","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"121","tags":["龙剑士-威风妖怪","龙剑士-雾动机龙","龙剑士-超重武者"],"matchup":{"first":{"decka":"龙剑士","win":"108","draw":"0","lose":"110"},"second":{"deckb":"龙剑士","win":"92","draw":"0","lose":"84"}}},{"name":"旋风黑羽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"118","tags":["旋风黑羽-深渊之兽","旋风黑羽-病毒"],"matchup":{"first":{"decka":"旋风黑羽","win":"82","draw":"0","lose":"92"},"second":{"deckb":"旋风黑羽","win":"108","draw":"0","lose":"79"}}},{"name":"自奏圣乐","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"111","tags":["自奏圣乐-废铁","自奏圣乐-朋克","自奏圣乐-深渊之兽"],"matchup":{"first":{"decka":"自奏圣乐","win":"104","draw":"0","lose":"101"},"second":{"deckb":"自奏圣乐","win":"129","draw":"0","lose":"98"}}},{"name":"六花","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"103","tags":["六花-圣天树","六花-兽带"],"matchup":{"first":{"decka":"六花","win":"129","draw":"0","lose":"96"},"second":{"deckb":"六花","win":"119","draw":"0","lose":"101"}}},{"name":"自然","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"100","tags":["自然-割草","自然-白雪","自然-神碑"],"matchup":{"first":{"decka":"自然","win":"163","draw":"0","lose":"149"},"second":{"deckb":"自然","win":"168","draw":"0","lose":"135"}}},{"name":"黄金国","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"92","tags":["黄金国-强金","黄金国-割草","黄金国-教导"],"matchup":{"first":{"decka":"黄金国","win":"93","draw":"0","lose":"101"},"second":{"deckb":"黄金国","win":"128","draw":"0","lose":"56"}}},{"name":"地中族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"91","tags":["地中族-强金"],"matchup":{"first":{"decka":"地中族","win":"104","draw":"0","lose":"101"},"second":{"deckb":"地中族","win":"77","draw":"0","lose":"84"}}},{"name":"神数","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"89","tags":["神数-龙星","神数-恩底弥翁","神数-超重武者"],"matchup":{"first":{"decka":"神数","win":"89","draw":"0","lose":"71"},"second":{"deckb":"神数","win":"100","draw":"0","lose":"46"}}},{"name":"妮穆蕾莉娅","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"88","tags":["妮穆蕾莉娅-暴食","妮穆蕾莉娅-强金","妮穆蕾莉娅-红莲魔兽"],"matchup":{"first":{"decka":"妮穆蕾莉娅","win":"47","draw":"0","lose":"73"},"second":{"deckb":"妮穆蕾莉娅","win":"76","draw":"0","lose":"56"}}},{"name":"忍者","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"87","tags":["忍者-杯面","忍者-强金","忍者-斩机"],"matchup":{"first":{"decka":"忍者","win":"64","draw":"0","lose":"62"},"second":{"deckb":"忍者","win":"72","draw":"0","lose":"50"}}},{"name":"转生炎兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"84","tags":["转生炎兽-斩机"],"matchup":{"first":{"decka":"转生炎兽","win":"57","draw":"0","lose":"81"},"second":{"deckb":"转生炎兽","win":"82","draw":"0","lose":"53"}}},{"name":"未界域暗黑界","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"84","tags":["未界域暗黑界-白雪","未界域暗黑界-病毒","未界域暗黑界-假面"],"matchup":{"first":{"decka":"未界域暗黑界","win":"46","draw":"0","lose":"75"},"second":{"deckb":"未界域暗黑界","win":"72","draw":"0","lose":"51"}}},{"name":"秘旋谍","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"79","tags":["秘旋谍-割草","秘旋谍-勇者","秘旋谍-朋克"],"matchup":{"first":{"decka":"秘旋谍","win":"82","draw":"0","lose":"55"},"second":{"deckb":"秘旋谍","win":"86","draw":"0","lose":"71"}}},{"name":"群豪","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"78","tags":["群豪-魔里","群豪-超重武者","群豪-神数"],"matchup":{"first":{"decka":"群豪","win":"69","draw":"0","lose":"60"},"second":{"deckb":"群豪","win":"52","draw":"0","lose":"42"}}},{"name":"火灵天星","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"77","tags":["火灵天星-斩机"],"matchup":{"first":{"decka":"火灵天星","win":"55","draw":"0","lose":"53"},"second":{"deckb":"火灵天星","win":"67","draw":"0","lose":"46"}}},{"name":"虹皇","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"75","tags":["虹皇-hero","虹皇-凤凰人","虹皇-假面"],"matchup":{"first":{"decka":"虹皇","win":"17","draw":"0","lose":"37"},"second":{"deckb":"虹皇","win":"77","draw":"0","lose":"38"}}},{"name":"星骑士","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"74","tags":["星骑士-次元场"],"matchup":{"first":{"decka":"星骑士","win":"54","draw":"0","lose":"46"},"second":{"deckb":"星骑士","win":"47","draw":"0","lose":"37"}}},{"name":"遗式","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"72","tags":["遗式-卫星闪灵","遗式-杯面"],"matchup":{"first":{"decka":"遗式","win":"64","draw":"0","lose":"54"},"second":{"deckb":"遗式","win":"68","draw":"0","lose":"52"}}},{"name":"抒情歌鸲","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"71","tags":["抒情歌鸲-七皇剑","抒情歌鸲-金华猫"],"matchup":{"first":{"decka":"抒情歌鸲","win":"79","draw":"0","lose":"57"},"second":{"deckb":"抒情歌鸲","win":"77","draw":"0","lose":"74"}}},{"name":"Metabeat","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"71","tags":["Metabeat-削命","Metabeat-强金","Metabeat-红莲魔兽"],"matchup":{"first":{"decka":"Metabeat","win":"72","draw":"0","lose":"56"},"second":{"deckb":"Metabeat","win":"78","draw":"0","lose":"59"}}},{"name":"龙辉巧","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"66","tags":["龙辉巧-电子化天使","龙辉巧-神光","龙辉巧-杯面"],"matchup":{"first":{"decka":"龙辉巧","win":"66","draw":"0","lose":"52"},"second":{"deckb":"龙辉巧","win":"74","draw":"0","lose":"35"}}},{"name":"电子龙","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"66","tags":["电子龙-银河","电子龙-暗电子","电子龙-兽带"],"matchup":{"first":{"decka":"电子龙","win":"22","draw":"0","lose":"38"},"second":{"deckb":"电子龙","win":"100","draw":"0","lose":"57"}}},{"name":"宝玉","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"63","tags":["宝玉-虹龙","宝玉-拯救的桥梁","宝玉-异热同心"],"matchup":{"first":{"decka":"宝玉","win":"31","draw":"0","lose":"58"},"second":{"deckb":"宝玉","win":"61","draw":"0","lose":"20"}}},{"name":"星圣","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"56","tags":["星圣-星骑士","星圣-次元场"],"matchup":{"first":{"decka":"星圣","win":"36","draw":"0","lose":"32"},"second":{"deckb":"星圣","win":"36","draw":"0","lose":"40"}}},{"name":"青眼","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"55","tags":["青眼-深渊之兽","青眼-假面","青眼-融合"],"matchup":{"first":{"decka":"青眼","win":"10","draw":"0","lose":"44"},"second":{"deckb":"青眼","win":"63","draw":"0","lose":"19"}}},{"name":"朋克","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"49","tags":["朋克-深渊之兽","朋克-割草","朋克-白雪"],"matchup":{"first":{"decka":"朋克","win":"53","draw":"0","lose":"53"},"second":{"deckb":"朋克","win":"58","draw":"0","lose":"49"}}},{"name":"恩底弥翁","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"48","tags":["恩底弥翁-滤抽","恩底弥翁-魔导兽","恩底弥翁-魔里"],"matchup":{"first":{"decka":"恩底弥翁","win":"51","draw":"0","lose":"58"},"second":{"deckb":"恩底弥翁","win":"56","draw":"0","lose":"33"}}},{"name":"咒眼","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"48","tags":["咒眼-强金","咒眼-俱舍怒威族"],"matchup":{"first":{"decka":"咒眼","win":"67","draw":"0","lose":"49"},"second":{"deckb":"咒眼","win":"59","draw":"1","lose":"56"}}},{"name":"海系","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"47","tags":["海系-俱舍怒威族","海系-冰水","海系-强金"],"matchup":{"first":{"decka":"海系","win":"21","draw":"0","lose":"21"},"second":{"deckb":"海系","win":"44","draw":"0","lose":"25"}}},{"name":"DD","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"46","tags":["DD-假面","DD-病毒"],"matchup":{"first":{"decka":"DD","win":"45","draw":"0","lose":"34"},"second":{"deckb":"DD","win":"43","draw":"0","lose":"36"}}},{"name":"幻影骑士团","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"44","tags":["幻影骑士团-朋克","幻影骑士团-未界域","幻影骑士团-深渊之兽"],"matchup":{"first":{"decka":"幻影骑士团","win":"40","draw":"0","lose":"50"},"second":{"deckb":"幻影骑士团","win":"57","draw":"0","lose":"36"}}},{"name":"银河光子","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"41","tags":["银河光子-深渊之兽","银河光子-七皇剑","银河光子-斩机"],"matchup":{"first":{"decka":"银河光子","win":"27","draw":"0","lose":"48"},"second":{"deckb":"银河光子","win":"50","draw":"0","lose":"18"}}},{"name":"幻变骚灵","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"41","tags":["幻变骚灵-强金","幻变骚灵-魔里"],"matchup":{"first":{"decka":"幻变骚灵","win":"47","draw":"0","lose":"43"},"second":{"deckb":"幻变骚灵","win":"51","draw":"0","lose":"35"}}},{"name":"同调士勇者同调系","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"40","tags":[],"matchup":{"first":{"decka":"同调士勇者同调系","win":"50","draw":"0","lose":"43"},"second":{"deckb":"同调士勇者同调系","win":"53","draw":"0","lose":"33"}}},{"name":"教导","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"37","tags":["教导-深渊之兽","教导-影依","教导-魔里"],"matchup":{"first":{"decka":"教导","win":"19","draw":"0","lose":"28"},"second":{"deckb":"教导","win":"24","draw":"0","lose":"29"}}},{"name":"恐龙族废铁","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"36","tags":["恐龙族废铁-进化药"],"matchup":{"first":{"decka":"恐龙族废铁","win":"42","draw":"0","lose":"39"},"second":{"deckb":"恐龙族废铁","win":"42","draw":"0","lose":"28"}}},{"name":"恐吓爪牙族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"35","tags":["恐吓爪牙族-俱舍怒威族"],"matchup":{"first":{"decka":"恐吓爪牙族","win":"48","draw":"0","lose":"25"},"second":{"deckb":"恐吓爪牙族","win":"33","draw":"0","lose":"27"}}},{"name":"海造贼","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"35","tags":["海造贼-勇者"],"matchup":{"first":{"decka":"海造贼","win":"49","draw":"0","lose":"49"},"second":{"deckb":"海造贼","win":"57","draw":"0","lose":"48"}}},{"name":"斩机","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"35","tags":["斩机-恐啡肽狂龙"],"matchup":{"first":{"decka":"斩机","win":"36","draw":"0","lose":"33"},"second":{"deckb":"斩机","win":"55","draw":"0","lose":"30"}}},{"name":"救援ACE队","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"32","tags":["救援ACE队-次元场","救援ACE队-强金"],"matchup":{"first":{"decka":"救援ACE队","win":"43","draw":"0","lose":"33"},"second":{"deckb":"救援ACE队","win":"40","draw":"0","lose":"21"}}},{"name":"战华","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"31","tags":["战华-强金","战华-黄金国"],"matchup":{"first":{"decka":"战华","win":"14","draw":"0","lose":"14"},"second":{"deckb":"战华","win":"29","draw":"0","lose":"29"}}},{"name":"魔偶甜点","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"31","tags":["魔偶甜点-超重武者"],"matchup":{"first":{"decka":"魔偶甜点","win":"29","draw":"0","lose":"30"},"second":{"deckb":"魔偶甜点","win":"33","draw":"0","lose":"25"}}},{"name":"勇者","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"27","tags":["勇者-深渊之兽","勇者-朋克","勇者-强金"],"matchup":{"first":{"decka":"勇者","win":"22","draw":"0","lose":"24"},"second":{"deckb":"勇者","win":"29","draw":"0","lose":"23"}}},{"name":"坏兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"27","tags":["坏兽-辉夜","坏兽-未界域","坏兽-白雪"],"matchup":{"first":{"decka":"坏兽","win":"9","draw":"0","lose":"9"},"second":{"deckb":"坏兽","win":"66","draw":"0","lose":"64"}}},{"name":"割草黯黑狱火机","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"26","tags":["割草黯黑狱火机-推理门","割草黯黑狱火机-强金","割草黯黑狱火机-白雪"],"matchup":{"first":{"decka":"割草黯黑狱火机","win":"4","draw":"0","lose":"9"},"second":{"deckb":"割草黯黑狱火机","win":"42","draw":"0","lose":"32"}}},{"name":"均卡beat","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"26","tags":["均卡beat-削命","均卡beat-辉夜","均卡beat-次元场"],"matchup":{"first":{"decka":"均卡beat","win":"45","draw":"0","lose":"34"},"second":{"deckb":"均卡beat","win":"49","draw":"0","lose":"30"}}},{"name":"龙剑士魔里","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"24","tags":["龙剑士魔里-威风妖怪","龙剑士魔里-雾动机龙","龙剑士魔里-超重武者"],"matchup":{"first":{"decka":"龙剑士魔里","win":"8","draw":"0","lose":"26"},"second":{"deckb":"龙剑士魔里","win":"25","draw":"0","lose":"9"}}},{"name":"魔女术","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"24","tags":["魔女术-魔里","魔女术-教导","魔女术-割草"],"matchup":{"first":{"decka":"魔女术","win":"15","draw":"0","lose":"27"},"second":{"deckb":"魔女术","win":"45","draw":"0","lose":"18"}}},{"name":"弗兰克特化","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"23","tags":["弗兰克特化-废铁","弗兰克特化-恐龙族"],"matchup":{"first":{"decka":"弗兰克特化","win":"3","draw":"0","lose":"12"},"second":{"deckb":"弗兰克特化","win":"12","draw":"0","lose":"0"}}},{"name":"淘气仙星","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"23","tags":["淘气仙星-强金","淘气仙星-暴食","淘气仙星-深渊之兽"],"matchup":{"first":{"decka":"淘气仙星","win":"6","draw":"0","lose":"14"},"second":{"deckb":"淘气仙星","win":"10","draw":"0","lose":"11"}}},{"name":"空牙团","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"22","tags":["空牙团-神碑","空牙团-卫星闪灵","空牙团-杯面"],"matchup":{"first":{"decka":"空牙团","win":"8","draw":"0","lose":"13"},"second":{"deckb":"空牙团","win":"14","draw":"0","lose":"8"}}},{"name":"PSY骨架","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"22","tags":["PSY骨架-超重武者","PSY骨架-同调系","PSY骨架-深渊之兽"],"matchup":{"first":{"decka":"PSY骨架","win":"17","draw":"0","lose":"16"},"second":{"deckb":"PSY骨架","win":"26","draw":"0","lose":"17"}}},{"name":"半龙女仆","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"21","tags":["半龙女仆-深渊之兽","半龙女仆-死狱乡","半龙女仆-烙印"],"matchup":{"first":{"decka":"半龙女仆","win":"16","draw":"0","lose":"21"},"second":{"deckb":"半龙女仆","win":"16","draw":"0","lose":"11"}}},{"name":"水四阶","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"20","tags":["水四阶-七皇剑","水四阶-斩机"],"matchup":{"first":{"decka":"水四阶","win":"4","draw":"0","lose":"14"},"second":{"deckb":"水四阶","win":"11","draw":"0","lose":"14"}}},{"name":"恐龙族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"20","tags":["恐龙族-进化药"],"matchup":{"first":{"decka":"恐龙族","win":"15","draw":"0","lose":"7"},"second":{"deckb":"恐龙族","win":"11","draw":"0","lose":"12"}}},{"name":"黑魔术师","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"20","tags":["黑魔术师-魔里","黑魔术师-传说之龙","黑魔术师-高仪"],"matchup":{"first":{"decka":"黑魔术师","win":"7","draw":"0","lose":"25"},"second":{"deckb":"黑魔术师","win":"19","draw":"0","lose":"12"}}},{"name":"护宝炮妖","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"19","tags":["护宝炮妖-斩机","护宝炮妖-兽带","护宝炮妖-割草"],"matchup":{"first":{"decka":"护宝炮妖","win":"21","draw":"0","lose":"8"},"second":{"deckb":"护宝炮妖","win":"25","draw":"0","lose":"13"}}},{"name":"三幻魔","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"19","tags":["三幻魔-混沌幻魔","三幻魔-假面","三幻魔-十二兽"],"matchup":{"first":{"decka":"三幻魔","win":"9","draw":"0","lose":"18"},"second":{"deckb":"三幻魔","win":"12","draw":"0","lose":"10"}}},{"name":"帝","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"19","tags":["帝-领域","帝-随风旅鸟","帝-虚无魔人"],"matchup":{"first":{"decka":"帝","win":"6","draw":"0","lose":"18"},"second":{"deckb":"帝","win":"16","draw":"0","lose":"3"}}},{"name":"辉夜坏兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"18","tags":["辉夜坏兽-次元场","辉夜坏兽-雪花","辉夜坏兽-超重武者"],"matchup":{"first":{"decka":"辉夜坏兽","win":"4","draw":"0","lose":"3"},"second":{"deckb":"辉夜坏兽","win":"52","draw":"0","lose":"36"}}},{"name":"教导召唤兽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"18","tags":["教导召唤兽-影依","教导召唤兽-割草","教导召唤兽-深渊之兽"],"matchup":{"first":{"decka":"教导召唤兽","win":"17","draw":"0","lose":"13"},"second":{"deckb":"教导召唤兽","win":"23","draw":"0","lose":"10"}}},{"name":"恐龙真龙","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"18","tags":["恐龙真龙-进化药","恐龙真龙-废铁"],"matchup":{"first":{"decka":"恐龙真龙","win":"24","draw":"0","lose":"11"},"second":{"deckb":"恐龙真龙","win":"21","draw":"1","lose":"19"}}},{"name":"末那愚子族","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"17","tags":["末那愚子族-深渊之兽","末那愚子族-卫星闪灵"],"matchup":{"first":{"decka":"末那愚子族","win":"15","draw":"0","lose":"22"},"second":{"deckb":"末那愚子族","win":"28","draw":"0","lose":"17"}}},{"name":"削命真龙","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"17","tags":["削命真龙-强金","削命真龙-次元场"],"matchup":{"first":{"decka":"削命真龙","win":"23","draw":"0","lose":"23"},"second":{"deckb":"削命真龙","win":"27","draw":"0","lose":"21"}}},{"name":"龙连接","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"17","tags":["龙连接-深渊之兽","龙连接-黑白龙","龙连接-无形噬体"],"matchup":{"first":{"decka":"龙连接","win":"24","draw":"0","lose":"11"},"second":{"deckb":"龙连接","win":"28","draw":"0","lose":"24"}}},{"name":"魔界剧团","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"16","tags":["魔界剧团-无形噬体","魔界剧团-病毒","魔界剧团-AF"],"matchup":{"first":{"decka":"魔界剧团","win":"9","draw":"0","lose":"8"},"second":{"deckb":"魔界剧团","win":"8","draw":"0","lose":"4"}}},{"name":"黑羽","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"16","tags":["黑羽-深渊之兽"],"matchup":{"first":{"decka":"黑羽","win":"13","draw":"0","lose":"16"},"second":{"deckb":"黑羽","win":"12","draw":"0","lose":"9"}}},{"name":"源数","recent_time":"2023-03-03T00:00:00.000Z","source":"mycard-athletic","count":"16","tags":["源数-翼神龙","源数-PSY","源数-七皇剑"],"matchup":{"first":{"decka":"源数","win":"4","draw":"0","lose":"12"},"second":{"deckb":"源数","win":"41","draw":"0","lose":"36"}}}]'
# typee = 1
pieChartSearch = on_command("查询饼图", aliases={"查饼图", "饼图查询"})
font = Path(font_path) / "qmzl.ttf"


@pieChartSearch.handle()
async def test(bot: Bot, event: Event, state: T_State):
    pie_date = httpx.get(url).json()
    # global typee
    # if typee == 1:
    #     pie_date = json.loads(json1)
    #     typee = 0
    # else:
    #     pie_date = json.loads(json2)
    #     typee = 1
    date_list = list()
    count_list = list()
    elseCount = 0
    fm.fontManager.addfont(font)
    prop = fm.FontProperties(fname=font)
    plt.rcParams['font.family'] = prop.get_name()
    plt.rcParams['font.sans-serif'] = prop.get_name()
    plt.rcParams['axes.unicode_minus'] = False
    for index, item in enumerate(pie_date):
        if index < 11:
            date_list.append(str(item['name']))
            count_list.append(int(item['count']))
        else:
            elseCount += int(item['count'])
    date_list.append("其他")
    count_list.append(elseCount)
    colors = plt.get_cmap('Blues')(numpy.linspace(0.9, 0.2, len(date_list)))
    fig = plt.figure("pie", frameon=False)
    canvas = fig.canvas
    plt.title("ygo饼图", fontsize=33, x=0.5, y=1.02)
    patches, l_text, p_text = plt.pie(count_list, labels=date_list, colors=colors, autopct='%1.1f%%')
    for t in l_text:
        t.set_size(16)
    for t in p_text:
        t.set_size(15)
    plt.axis('off')

    fig.set_size_inches(512 / 80, 512 / 80)

    plt.gca().xaxis.set_major_locator(plt.NullLocator())  # plt.gca()表示获取当前子图"Get Current Axes"。

    plt.gca().yaxis.set_major_locator(plt.NullLocator())

    plt.margins(0, 0)
    plt.close()
    buffer = io.BytesIO()  # 获取输入输出流对象

    canvas.print_png(buffer)  # 将画布上的内容打印到输入输出流对象

    data = buffer.getvalue()  # 获取流的值

    buffer.write(data)  # 将数据写入buffer

    img = Image.open(buffer)  # 使用Image打开图片数据

    img_back = Image.open(Path(image_path) / "pie_back.png")

    pie_width, pie_height = img.size

    back_width, back_height = img_back.size

    loca = (int((back_width - pie_width) / 2), int((back_height - pie_height) / 2)+20)

    img_back.paste(img, loca, mask=img)

    # =========备注添加==============
    source = ImageFont.truetype(str(font), 15)
    timefont = ImageFont.truetype(str(font), 25)
    time_up = pie_date[0]['recent_time']
    draw = ImageDraw.Draw(img_back)

    draw.text((int(back_width * 0.7), int(back_height * 0.05)), "数据来源:萌卡数据库", fill=(0, 0, 0), font=source)
    draw.text((int(back_width * 0.1), int(back_height * 0.9)), '更新时间：' + time_up.split("T")[0], fill=(0, 0, 0),
              font=timefont)
    # =========发送==============
    await pieChartSearch.finish(Message([
        MessageSegment("image", {
            "file": f"base64://{str(image_to_base64(img_back), encoding='utf-8')}"
        })]))
